<template>
  <div>
    <h2 class="font-medium" :class="{ 'text-lg': !isContact }">{{ question.title }}</h2>
    <el-text v-if="question.subtitle">{{ question.subtitle }}</el-text>
    <div class="mt-4">
      <el-radio-group v-if="question.tag !== 'select'" v-model="radio">
        <template :key="answer.name" v-for="answer in options">
          <el-radio class="w-full" size="large" v-if="answer.isActive(userAnswers)" :label="answer.name">{{
            answer.title
          }}</el-radio>
        </template>
      </el-radio-group>

      <el-select v-else v-model="radio" class="" placeholder="Select" size="large">
        <el-option
          v-for="answer in options"
          :key="answer.name"
          :label="answer.title"
          :value="answer.name"
        />
      </el-select>
    </div>
  </div>
</template>

<script setup>
import { computed, onMounted, ref, watch } from 'vue'
import { defineType } from '../data'
import optionsData from '../data/options'

const props = defineProps({
  question: {
    type: Object
  },
  userAnswers: {
    type: Array
  },
  handleUserAnswer: {
    type: Function
  },
  isContact: {
    type: Boolean,
    default: false
  }
})

const getOptionsByQuestionName = (questionName) => {
  return optionsData.filter((item) => item.parent === questionName)
}

const options = computed(() => getOptionsByQuestionName(props.question.name))

const findValueRadio = () => {
  const index = props.userAnswers.findIndex((item) => item.question.name == props.question.name)
  let value = null
  if (index !== -1) {
    value = props.userAnswers[index][defineType.single]
  }

  if(value == null && props.question.tag == 'select'){
    value = options.value[0].name || null
  }
  
  return value
}
const radio = ref(findValueRadio())

const updateSingleChoice = () => {
  props.handleUserAnswer({
    question: props.question,
    ans: radio.value
  })
}

watch(
  () => props.question,
  () => {
    radio.value = findValueRadio()
  }
)


watch(radio, () => {
  updateSingleChoice()
})

if(props.question.tag === 'select'){
  updateSingleChoice()
}
</script>
